
// Licensed Materials - Use restricted. For use in compiling interfaces to
// IBM Rational TestManager.
// (c) Copyright IBM Corporation 2001, 2002, 2006.  All Rights Reserved.

////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////
// Includes
////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////


#include <windows.h>
#include <tchar.h>

#include "ExtDefs.h"
#include "proxhdr.h"
#include "psystem.h"
#include "plibdefs.h"
// local
#include "APIFilteringAdapter.h"

static unsigned int uiLibID = 0;
static int protocolConnectionNumber = 0;

char buf2;
#define RSR_EXT_STUB_SILENT "RSR_EXT_STUB_SILENT"

////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////
// Function Definitions
////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////

/*
This example API Filtering DLL looks for records recorded
by the SampleAPIWrapper.dll project in the .wch file


*/

BOOL IsAPIGenFiltExtAdapter()
{
	return TRUE;	
}

int GetDisplayName(TCHAR* name, size_t nameSize)
{
	TCHAR buf[] = "HelloWorld.dll scripting";

	if (_tcslen(buf) <  nameSize)
	{
		_tcscpy(name, buf);

#ifdef _DEBUG
		if(!GetEnvironmentVariable(RSR_EXT_STUB_SILENT,&buf2,0))
			MessageBox(NULL, "get Display name called and succeeded", "HelloWorld Filter adapter", MB_OK);
#endif // def _DEBUG

		return RSR_SUCCESS;
	}
	else
	{
		return RSR_ERROR;
	}


}

int GetScriptgenDllName(TCHAR* name, size_t nameSize)
{
	TCHAR buf[] = "APIScriptGeneratorAdapter.dll";

		_tcscpy(name, buf);

#ifdef _DEBUG
	if(!GetEnvironmentVariable(RSR_EXT_STUB_SILENT,&buf2,0))
		MessageBox(NULL, name, "filter, HelloWorld Filter getscriptgenname", MB_OK);
#endif // def _DEBUG

		return RSR_SUCCESS;
}

int GetOptions(TCHAR* options, size_t optionsSize)
{

     TCHAR opVar[4096];    
     _tcscpy(options, _T(""));

    if (GetEnvironmentVariable(_T("RSR_FILTER_OPTIONS"), opVar, 4096) != 0)
    {   
		_tcscpy(options, opVar);
        return RSR_SUCCESS;
    }

    _tcscat(options, "options;options");
    
    if (_tcslen(options)+1 > optionsSize)
        return RSR_BUFFER_TOO_SHORT;
    else
        return RSR_SUCCESS;
}

int SetOptions(TCHAR* options, size_t optionsSize, TCHAR* errorMsg, size_t errorMsgSize)
{
	return RSR_SUCCESS;
}

int DisplayCustomConfigGUI(TCHAR* errorMessage,
                        size_t errorMessageSize)
{
	return RSR_SUCCESS;
}


int CheckAPIPacket(void* packet,
                        int  IDNum,
                        int* NextConn,
                        int* clientIP,
                        int* clientPort,
                        int* serverIP,
                        int* serverPort)
{

	major_wch_header *majorhdr;
#ifdef _DEBUG
	char buf[MAX_PATH];
#endif // def _DEBUG


	majorhdr = packet;
	// this example doesn't pass any packet type besides API_SINGLE
	// on to the script generator
	if (majorhdr->major_type == API_SINGLE)
	{
		minor_wch_header *minorhdr = (minor_wch_header *)((char*)packet + sizeof(major_wch_header));
		// I'm interested in the following packet types
		switch (IDNum)
		{	
			// add filters for other libraries here
			case PROXY_LIB_WINDOWS_SYSTEM:
					// check all the customer adapter records
					// to see if it is ours
					if (minorhdr->API_id != P_CUSTOMADAPTER_A)
					{
						*NextConn = 0;
					}
					else
					{	// custom adapter record, let's
						// see if it is ours
						S_CUSTOMADAPTER *custadapter = (S_CUSTOMADAPTER *)((char*)packet + sizeof(major_wch_header)
							+ sizeof(minor_wch_header) + sizeof(stamp2_wch_header));
						void *p = (void *)((char*)packet + sizeof(major_wch_header)
							+ sizeof(minor_wch_header)  + sizeof(stamp2_wch_header) + custadapter->iOffszLibraryName);
						char *szLibName = (char *)p;
						if (stricmp(szLibName, "APIRecordingAdapter.dll") == 0)
						{
							uiLibID = custadapter->uiLibID;
							protocolConnectionNumber = *NextConn;
#ifdef _DEBUG
							MessageBox(NULL, szLibName, "Identified System library record",  MB_OK);
#endif // def _DEBUG
						}
						else
							*NextConn = 0;

					}
					break;
			default:
					// check for any records that are to be thrown away
#ifdef _DEBUG
					wsprintf(buf,"default processing libID=%d looking for uiLibID=%d",IDNum, uiLibID);
					MessageBox(NULL,buf,"HelloWorld non sys packet", MB_OK);
#endif // def _DEBUG

					if (IDNum != (int)uiLibID)
						*NextConn = 0;
					if (uiLibID == 0)
						*NextConn = 0;
					if (IDNum == (int)uiLibID)
					{
						*NextConn = protocolConnectionNumber;
#ifdef _DEBUG
						wsprintf(buf,"processing with good data packet conn number=%d looking for uiLibID=%d", *NextConn, uiLibID);
						MessageBox(NULL,buf,"HelloWorld Filter", MB_OK);
#endif // def _DEBUG

					}
					break;
					
		}

	}
	else
	{
		*NextConn = 0;
	}


	return RSR_SUCCESS;
}


